Option Explicit 


 
'********************************************************************************
'  <<< [XL] >>> 
'********************************************************************************
Dim g_x
Function  XL()
  If IsEmpty( g_x ) Then _
    Set g_x = WScript.CreateObject("Excel.Application") : g_x.Visible = True
  Set XL = g_x
End Function

 
'********************************************************************************
'  <<< [XF] >>> 
'********************************************************************************
Function  XF()
  Set XF = XL.WorksheetFunction
End Function
 
'********************************************************************************
'  <<< [Sheet_open] >>> 
'********************************************************************************
Function  Sheet_open( path )
  Dim excel : Set excel = XL()
  Dim fs : Set fs = WScript.CreateObject( "Scripting.FileSystemObject" )
  Dim file : Set file = excel.WorkBooks.Open( fs.GetAbsolutePathName( path ) )
  Set  Sheet_open = file.ActiveSheet
End Function
 
'********************************************************************************
'  <<< [Sheet_new] >>> 
'********************************************************************************
Function  Sheet_new( before_sheet )
  If IsEmpty( before_sheet ) Then
    Dim excel : Set excel = XL()
    excel.SheetsInNewWorkbook = 1
    Set Sheet_new = excel.WorkBooks.Add().ActiveSheet
  Else
    Set Sheet_new = before_sheet.parent.Worksheets.Add( , before_sheet )
  End If
End Function
 
'********************************************************************************
'  <<< [Cell_newFromRangeObj] >>> 
'********************************************************************************
Function  Cell_newFromRangeObj( range )
  Dim  cell : Set cell = New XCell
  Set cell.m_Obj = range
  Set Cell_newFromRangeObj = cell
End Function
 
'********************************************************************************
'  <<< [Cell_get] >>> 
'********************************************************************************
Function  Cell_get( sheet, cell_name )
  Dim  cell : Set cell = New XCell
  Set cell.m_Obj = sheet.Range( cell_name )
  Set Cell_get = cell
End Function
 
'********************************************************************************
'  <<< [Cell_find] >>> 
'********************************************************************************
Function  Cell_find( sheet, start_cell_name, keyword, dx, dy )
  Dim  cell : Set cell = New XCell
  Set cell.m_Obj = sheet.Range( start_cell_name )
  Set cell.m_Obj = cell.m_Obj.Find( keyword )
  If cell.m_Obj Is Nothing Then  Err.raise 1,,"[ERROR] Not Found " + start_cell_name
  Set cell.m_Obj = sheet.Cells( cell.m_Obj.Row+dy, cell.m_Obj.Column+dx )
  Set Cell_find = cell
End Function
 
'********************************************************************************
'  <<< [Selection] >>> 
'********************************************************************************
Function  Selection()
  Dim  x : Set x = XL()
  Set  Selection = Cell_newFromRangeObj( x.Selection )
End Function


 
'*-------------------------------------------------------------------------*
'* <<<< [XCell] Class >>>> */ 
'*-------------------------------------------------------------------------*
Class  XCell
  Public  m_Obj

  Public Function  Step( dx, dy )
    Set Step = New XCell
    Set Step.m_Obj = m_Obj.parent.Cells( m_Obj.Row+dy, m_Obj.Column+dx )
  End Function

  Public Function  StepRange( dx, dy, width, height )
    Set StepRange = New XCell
    Set StepRange.m_Obj = m_Obj.parent.Range( _
       m_Obj.parent.Cells( m_Obj.Row+dy, m_Obj.Column+dx ), _
       m_Obj.parent.Cells( m_Obj.Row+dy+height-1, m_Obj.Column+dx+width-1 ) )
  End Function

  Public Sub  Copy() : m_Obj.Copy : End Sub
  Public Sub  Paste() : m_Obj.PasteSpecial : End Sub
End Class
 
'********************************************************************************
'  <<< [ExitClipboardMode] >>> 
'********************************************************************************
Sub  ExitClipboardMode()
  Dim excel : Set excel = XL()
  excel.CutCopyMode = False
End Sub
 
